Subject: Re: Saving to 32 bits of GPRs in signal context

From: Segher Boessenkool <[email-masked]>
Date: Wed, 30 May 2007 13:40:44 +0200

>> Also if you want to debug this code (see long long variables 
>> correctly from
>> GDB or even see the upper 32-bits of GPRs) you will need an ABI 
>> change so
>> that GDB/DWARF knows what to do.
>
> I personally don't care about gdb seeing those or anything like that,
> those would be strictly local asm optimisations, at least that's my
> point of view on the matter.

GDB can step into asm though, it will have to know
about it for full functionality.

> I intend not to extend or change the shape of ucontext neither. I'll 
> add
> the highregs after the ucontext32 on the compat signal frame, the only
> change/addition is the use of a pad field to point to it and maybe
> setting a flag that was previously unused and always 0 to indicate that
> it's there.
>
> Do you see any possible compatibility problem there ? Do you know of 
> any
> piece of software that makes hard assumptions on the shape and size of 
> a
> complete signal frame (not just the ucontext part of it) ?

Perhaps something in a test suite somewhere; other
than that, nothing important I suspect.  Well some
version of some JVM will abuse it I'm sure ;-)

Segher